diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 8ca6deb90b6..a9c57e136de 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -92,10 +92,9 @@ struct JoyDev
 };
 
 typedef struct JoystickImpl JoystickImpl;
-static const IDirectInputDevice8WVtbl JoystickWvt;
 struct JoystickImpl
 {
-        struct JoystickGenericImpl generic;
+        struct JoystickGenericImpl *generic;
 
         struct JoyDev                  *joydev;
 
@@ -130,12 +129,14 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr);
 static HRESULT CDECL unix_joystick_acquire(struct unix_joystick *ptr);
 static HRESULT CDECL unix_joystick_unacquire(struct unix_joystick *ptr);
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count, BOOL *has_ff);
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, JoystickGenericImpl *generic, ObjProps *props, int *prop_count, BOOL *has_ff);
+static void CDECL unix_joystick_destroy(struct unix_joystick *ptr);
 static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis_count, const int **axes_map);
 
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
     unix_joystick_init,
+    unix_joystick_destroy,
     NULL,
     unix_joystick_get_mapping,
     unix_joystick_acquire,
@@ -363,7 +364,7 @@ static INT find_joystick_devices(void)
     return joystick_devices_count;
 }
 
-static void fill_joystick_dideviceinstanceW(LPDIDEVICEINSTANCEW lpddi, DWORD version, int id)
+static void fill_joystick_dideviceinstanceA(LPDIDEVICEINSTANCEA lpddi, DWORD version, int id)
 {
     DWORD dwSize = lpddi->dwSize;
 
@@ -389,32 +390,9 @@ static void fill_joystick_dideviceinstanceW(LPDIDEVICEINSTANCEW lpddi, DWORD ver
             lpddi->wUsage = 0x05; /* Game Pad */
     }
 
-    MultiByteToWideChar(CP_ACP, 0, joystick_devices[id].name, -1, lpddi->tszInstanceName, MAX_PATH);
-    MultiByteToWideChar(CP_ACP, 0, joystick_devices[id].name, -1, lpddi->tszProductName, MAX_PATH);
-    lpddi->guidFFDriver = GUID_NULL;
-}
-
-static void fill_joystick_dideviceinstanceA(LPDIDEVICEINSTANCEA lpddi, DWORD version, int id)
-{
-    DIDEVICEINSTANCEW lpddiW;
-    DWORD dwSize = lpddi->dwSize;
-
-    lpddiW.dwSize = sizeof(lpddiW);
-    fill_joystick_dideviceinstanceW(&lpddiW, version, id);
-
-    TRACE("%d %p\n", dwSize, lpddi);
-    memset(lpddi, 0, dwSize);
-
-    /* Convert W->A */
-    lpddi->dwSize = dwSize;
-    lpddi->guidInstance = lpddiW.guidInstance;
-    lpddi->guidProduct = lpddiW.guidProduct;
-    lpddi->dwDevType = lpddiW.dwDevType;
     strcpy(lpddi->tszInstanceName, joystick_devices[id].name);
     strcpy(lpddi->tszProductName,  joystick_devices[id].name);
-    lpddi->guidFFDriver = lpddiW.guidFFDriver;
-    lpddi->wUsagePage = lpddiW.wUsagePage;
-    lpddi->wUsage = lpddiW.wUsage;
+    lpddi->guidFFDriver = GUID_NULL;
 }
 
 static HRESULT joydev_enum_deviceA(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEA lpddi, DWORD version, int id)
@@ -466,36 +444,30 @@ static unsigned short get_joystick_index(REFGUID guid)
     return MAX_JOYSTICKS;
 }
 
-static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID guid, JoystickGenericImpl **out)
+static HRESULT joydev_create_unix_joystick(REFGUID guid, DWORD version, const struct unix_joystick_vtbl **vtbl, struct unix_joystick **ptr, WORD *vid, WORD *pid, WORD *iid, DIDEVICEINSTANCEA *info)
 {
     struct JoyDev *joydev;
-    DIDEVICEINSTANCEW didi = {sizeof(didi)};
     JoystickImpl *newDevice;
-    HRESULT hr;
     DWORD index;
 
-    TRACE("%p %s %p\n", dinput, debugstr_guid(guid), out);
-
     find_joystick_devices();
 
-    *out = NULL;
     if ((index = get_joystick_index(guid)) >= MAX_JOYSTICKS || !joystick_devices_count || index >= joystick_devices_count)
         return DIERR_DEVICENOTREG;
     joydev = &joystick_devices[index];
 
-    fill_joystick_dideviceinstanceW(&didi, dinput->dwVersion, index);
-
-    if (FAILED(hr = direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, guid, joydev->vendor_id,
-                       joydev->product_id, index, &didi, dinput, (void **)&newDevice)))
-        return hr;
-    newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->generic.base.crit");
-    newDevice->generic.unix_funcs = &unix_joystick_vtbl;
-    newDevice->generic.unix_ptr = unix_joystick_from_impl(newDevice);
+    fill_joystick_dideviceinstanceA(info, version, index);
 
+    if (!(newDevice = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(*newDevice)))) return DIERR_OUTOFMEMORY;
     newDevice->joydev = joydev;
     newDevice->joyfd = -1;
 
-    *out = &newDevice->generic;
+    *vid = joydev->vendor_id;
+    *pid = joydev->product_id;
+    *iid = index;
+    *vtbl = &unix_joystick_vtbl;
+    *ptr = unix_joystick_from_impl(newDevice);
+
     return DI_OK;
 }
 
@@ -506,16 +478,18 @@ static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis
     *axes_map = This->joydev->axes_map;
 }
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count, BOOL *has_ff)
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, JoystickGenericImpl *generic, ObjProps *props, int *prop_count, BOOL *has_ff)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
     int i, idx = 0, wine_obj;
 
+    This->generic = generic;
+
     for (i = 0; i < This->joydev->axis_count; i++)
     {
         if ((idx = This->joydev->axes_map[i]) >= 0)
         {
-            wine_obj = win32_funcs->joystick_get_axis(&This->generic, i);
+            wine_obj = win32_funcs->joystick_get_axis(This->generic, i);
             if (wine_obj < 0) props[idx].dwType = 0;
             else if (wine_obj < 8) props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj) | DIDFT_ABSAXIS;
             else props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj - 8) | DIDFT_POV;
@@ -529,6 +503,12 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
     return DI_OK;
 }
 
+static void CDECL unix_joystick_destroy(struct unix_joystick *ptr)
+{
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
+    HeapFree(GetProcessHeap(), 0, This);
+}
+
 #undef MAX_JOYSTICKS
 
 const struct dinput_device joystick_linux_device = {
@@ -606,60 +586,24 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
         TRACE("js_event: type 0x%x, number %d, value %d\n",
               jse.type,jse.number,jse.value);
         if (jse.type & JS_EVENT_BUTTON)
-            win32_funcs->joystick_queue_event(&This->generic, DIDFT_PSHBUTTON, jse.number, jse.value ? 0x80 : 0x00);
+            win32_funcs->joystick_queue_event(This->generic, DIDFT_PSHBUTTON, jse.number, jse.value ? 0x80 : 0x00);
         else if (jse.type & JS_EVENT_AXIS)
         {
-            int axis = win32_funcs->joystick_get_axis(&This->generic, jse.number);
+            int axis = win32_funcs->joystick_get_axis(This->generic, jse.number);
             if (axis < 0) return;
             TRACE("changing axis %d => %d\n", jse.number, axis);
-            if (axis >= 0 && axis < 8) win32_funcs->joystick_queue_event(&This->generic, DIDFT_ABSAXIS, axis, jse.value);
+            if (axis >= 0 && axis < 8) win32_funcs->joystick_queue_event(This->generic, DIDFT_ABSAXIS, axis, jse.value);
             else if (axis >= 8 && axis < 12)
             {
                 if (jse.number % 2) This->povs[axis - 8].y = jse.value;
                 else This->povs[axis - 8].x = jse.value;
-                win32_funcs->joystick_queue_event(&This->generic, DIDFT_POV, axis - 8, joystick_map_pov(&This->povs[axis - 8]));
+                win32_funcs->joystick_queue_event(This->generic, DIDFT_POV, axis - 8, joystick_map_pov(&This->povs[axis - 8]));
             }
             else WARN("axis %d not supported\n", axis);
         }
     }
 }
 
-static const IDirectInputDevice8WVtbl JoystickWvt =
-{
-    IDirectInputDevice2WImpl_QueryInterface,
-    IDirectInputDevice2WImpl_AddRef,
-    IDirectInputDevice2WImpl_Release,
-    JoystickWGenericImpl_GetCapabilities,
-    IDirectInputDevice2WImpl_EnumObjects,
-    JoystickWGenericImpl_GetProperty,
-    JoystickWGenericImpl_SetProperty,
-    JoystickWGenericImpl_Acquire,
-    JoystickWGenericImpl_Unacquire,
-    JoystickWGenericImpl_GetDeviceState,
-    IDirectInputDevice2WImpl_GetDeviceData,
-    IDirectInputDevice2WImpl_SetDataFormat,
-    IDirectInputDevice2WImpl_SetEventNotification,
-    IDirectInputDevice2WImpl_SetCooperativeLevel,
-    JoystickWGenericImpl_GetObjectInfo,
-    IDirectInputDevice2WImpl_GetDeviceInfo,
-    IDirectInputDevice2WImpl_RunControlPanel,
-    IDirectInputDevice2WImpl_Initialize,
-    IDirectInputDevice2WImpl_CreateEffect,
-    IDirectInputDevice2WImpl_EnumEffects,
-    IDirectInputDevice2WImpl_GetEffectInfo,
-    IDirectInputDevice2WImpl_GetForceFeedbackState,
-    IDirectInputDevice2WImpl_SendForceFeedbackCommand,
-    IDirectInputDevice2WImpl_EnumCreatedEffectObjects,
-    IDirectInputDevice2WImpl_Escape,
-    JoystickWGenericImpl_Poll,
-    IDirectInputDevice2WImpl_SendDeviceData,
-    IDirectInputDevice7WImpl_EnumEffectsInFile,
-    IDirectInputDevice7WImpl_WriteEffectToFile,
-    JoystickWGenericImpl_BuildActionMap,
-    JoystickWGenericImpl_SetActionMap,
-    IDirectInputDevice8WImpl_GetImageInfo
-};
-
 #else  /* HAVE_LINUX_22_JOYSTICK_API */
 
 const struct dinput_device joystick_linux_device = {
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 8ed22d5bcfc..7c9fdba9418 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -91,7 +91,6 @@ HRESULT linuxinput_create_effect(int *fd, REFGUID rguid, DWORD type, const DIEFF
 HRESULT linuxinput_get_info_A(int fd, REFGUID rguid, LPDIEFFECTINFOA info);
 
 typedef struct JoystickImpl JoystickImpl;
-static const IDirectInputDevice8WVtbl JoystickWvt;
 
 struct JoyDev {
 	char *device;
@@ -124,7 +123,7 @@ struct JoyDev {
 
 struct JoystickImpl
 {
-        struct JoystickGenericImpl      generic;
+        struct JoystickGenericImpl     *generic;
         struct JoyDev                  *joydev;
 
 	/* joystick private */
@@ -164,13 +163,15 @@ static HRESULT CDECL unix_joystick_get_effect_info(struct unix_joystick *ptr, RE
 static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, DWORD type, const DIEFFECT *effect,
         const struct unix_effect_vtbl **vtbl, struct unix_effect **out);
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count, BOOL *has_ff);
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, JoystickGenericImpl *generic, ObjProps *props, int *prop_count, BOOL *has_ff);
+static void CDECL unix_joystick_destroy(struct unix_joystick *ptr);
 static void CDECL unix_joystick_reset(struct unix_joystick *ptr);
 static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis_count, const int **axes_map);
 
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
     unix_joystick_init,
+    unix_joystick_destroy,
     unix_joystick_reset,
     unix_joystick_get_mapping,
     unix_joystick_acquire,
@@ -415,7 +416,7 @@ static void find_joydevs(void)
     }
 }
 
-static void fill_joystick_dideviceinstanceW(LPDIDEVICEINSTANCEW lpddi, DWORD version, int id)
+static void fill_joystick_dideviceinstanceA(LPDIDEVICEINSTANCEA lpddi, DWORD version, int id)
 {
     DWORD dwSize = lpddi->dwSize;
 
@@ -440,31 +441,8 @@ static void fill_joystick_dideviceinstanceW(LPDIDEVICEINSTANCEW lpddi, DWORD ver
             lpddi->wUsage = 0x05; /* Game Pad */
     }
 
-    MultiByteToWideChar(CP_ACP, 0, joydevs[id].name, -1, lpddi->tszInstanceName, MAX_PATH);
-    MultiByteToWideChar(CP_ACP, 0, joydevs[id].name, -1, lpddi->tszProductName, MAX_PATH);
-}
-
-static void fill_joystick_dideviceinstanceA(LPDIDEVICEINSTANCEA lpddi, DWORD version, int id)
-{
-    DIDEVICEINSTANCEW lpddiW;
-    DWORD dwSize = lpddi->dwSize;
-
-    lpddiW.dwSize = sizeof(lpddiW);
-    fill_joystick_dideviceinstanceW(&lpddiW, version, id);
-
-    TRACE("%d %p\n", dwSize, lpddi);
-    memset(lpddi, 0, dwSize);
-
-    /* Convert W->A */
-    lpddi->dwSize = dwSize;
-    lpddi->guidInstance = lpddiW.guidInstance;
-    lpddi->guidProduct = lpddiW.guidProduct;
-    lpddi->dwDevType = lpddiW.dwDevType;
     lstrcpynA(lpddi->tszInstanceName, joydevs[id].name, MAX_PATH);
     lstrcpynA(lpddi->tszProductName,  joydevs[id].name, MAX_PATH);
-    lpddi->guidFFDriver = lpddiW.guidFFDriver;
-    lpddi->wUsagePage = lpddiW.wUsagePage;
-    lpddi->wUsage = lpddiW.wUsage;
 }
 
 static HRESULT joydev_enum_deviceA(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEA lpddi, DWORD version, int id)
@@ -512,36 +490,30 @@ static unsigned short get_joystick_index(REFGUID guid)
     return MAX_JOYDEV;
 }
 
-static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID guid, JoystickGenericImpl **out)
+static HRESULT joydev_create_unix_joystick(REFGUID guid, DWORD version, const struct unix_joystick_vtbl **vtbl, struct unix_joystick **ptr, WORD *vid, WORD *pid, WORD *iid, DIDEVICEINSTANCEA *info)
 {
     struct JoyDev *joydev;
-    DIDEVICEINSTANCEW didi = {sizeof(didi)};
     JoystickImpl *newDevice;
-    HRESULT hr;
     int index;
 
-    TRACE("%p %s %p\n", dinput, debugstr_guid(guid), out);
-
     find_joydevs();
 
-    *out = NULL;
     if ((index = get_joystick_index(guid)) >= MAX_JOYDEV || !have_joydevs || index >= have_joydevs)
         return DIERR_DEVICENOTREG;
     joydev = &joydevs[index];
 
-    fill_joystick_dideviceinstanceW(&didi, dinput->dwVersion, index);
-
-    if (FAILED(hr = direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, guid, joydev->vendor_id,
-                       joydev->product_id, index, &didi, dinput, (void **)&newDevice)))
-        return hr;
-    newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->base.crit");
-    newDevice->generic.unix_funcs = &unix_joystick_vtbl;
-    newDevice->generic.unix_ptr = unix_joystick_from_impl(newDevice);
+    fill_joystick_dideviceinstanceA(info, version, index);
 
+    if (!(newDevice = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(*newDevice)))) return DIERR_OUTOFMEMORY;
     newDevice->joyfd       = -1;
     newDevice->joydev = joydev;
 
-    *out = &newDevice->generic;
+    *vid = joydev->vendor_id;
+    *pid = joydev->product_id;
+    *iid = index;
+    *vtbl = &unix_joystick_vtbl;
+    *ptr = unix_joystick_from_impl(newDevice);
+
     return DI_OK;
 }
 
@@ -552,11 +524,13 @@ static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis
     *axes_map = This->joydev->axes_map;
 }
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count, BOOL *has_ff)
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, JoystickGenericImpl *generic, ObjProps *props, int *prop_count, BOOL *has_ff)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
     int i, idx = 0, wine_obj;
 
+    This->generic = generic;
+
 #ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
     This->ff_state = FF_STATUS_STOPPED;
 #endif
@@ -574,7 +548,7 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
             props[idx].lDevMin = This->joydev->axes[i].minimum;
             props[idx].lDevMax = This->joydev->axes[i].maximum;
 
-            wine_obj = win32_funcs->joystick_get_axis(&This->generic, idx);
+            wine_obj = win32_funcs->joystick_get_axis(This->generic, idx);
             if (wine_obj < 0) props[idx].dwType = 0;
             else if (wine_obj < 8) props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj) | DIDFT_ABSAXIS;
             else props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj - 8) | DIDFT_POV;
@@ -590,7 +564,7 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
             props[idx].lDevMin = This->joydev->axes[ABS_HAT0X + i * 2].minimum;
             props[idx].lDevMax = This->joydev->axes[ABS_HAT0X + i * 2].maximum;
 
-            wine_obj = win32_funcs->joystick_get_axis(&This->generic, idx);
+            wine_obj = win32_funcs->joystick_get_axis(This->generic, idx);
             if (wine_obj < 0) props[idx].dwType = 0;
             else if (wine_obj < 8) props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj) | DIDFT_ABSAXIS;
             else props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj - 8) | DIDFT_POV;
@@ -601,7 +575,7 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
             props[idx].lDevMin = This->joydev->axes[ABS_HAT0Y + i * 2].minimum;
             props[idx].lDevMax = This->joydev->axes[ABS_HAT0Y + i * 2].maximum;
 
-            wine_obj = win32_funcs->joystick_get_axis(&This->generic, idx);
+            wine_obj = win32_funcs->joystick_get_axis(This->generic, idx);
             if (wine_obj < 0) props[idx].dwType = 0;
             else if (wine_obj < 8) props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj) | DIDFT_ABSAXIS;
             else props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj - 8) | DIDFT_POV;
@@ -616,6 +590,12 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
     return DI_OK;
 }
 
+static void CDECL unix_joystick_destroy(struct unix_joystick *ptr)
+{
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
+    HeapFree(GetProcessHeap(), 0, This);
+}
+
 const struct dinput_device joystick_linuxinput_device = {
   "Wine Linux-input joystick driver",
   joydev_enum_deviceA,
@@ -713,7 +693,7 @@ static HRESULT CDECL unix_joystick_ff_set_gain(struct unix_joystick *ptr, DWORD
     struct input_event event;
 
     This->ff_gain = MulDiv(value, 0xFFFF, 10000);
-    if (!This->generic.base.acquired) return DI_OK;
+    if (This->joyfd == -1) return DI_OK;
 
     event.type = EV_FF;
     event.code = FF_GAIN;
@@ -729,7 +709,7 @@ static HRESULT CDECL unix_joystick_ff_set_gain(struct unix_joystick *ptr, DWORD
  */
 #define CENTER_AXIS(a) \
     if ((axis = This->joydev->dev_axes_to_di[a]) >= 0) \
-        win32_funcs->joystick_queue_event(&This->generic, DIDFT_ABSAXIS, axis, This->joydev->axes[a].value)
+        win32_funcs->joystick_queue_event(This->generic, DIDFT_ABSAXIS, axis, This->joydev->axes[a].value)
 static void CDECL unix_joystick_reset(struct unix_joystick *ptr)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
@@ -773,22 +753,22 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
         {
             int btn = This->joydev->buttons[ie.code];
             TRACE("(%p) %d -> %d\n", This, ie.code, btn);
-            if (btn & 0x80) win32_funcs->joystick_queue_event(&This->generic, DIDFT_PSHBUTTON, btn & 0x7f, ie.value ? 0x80 : 0x00);
+            if (btn & 0x80) win32_funcs->joystick_queue_event(This->generic, DIDFT_PSHBUTTON, btn & 0x7f, ie.value ? 0x80 : 0x00);
             break;
         }
 	case EV_ABS:
         {
             int axis = This->joydev->dev_axes_to_di[ie.code];
             if (axis < 0) break;
-            axis = win32_funcs->joystick_get_axis(&This->generic, axis);
+            axis = win32_funcs->joystick_get_axis(This->generic, axis);
             if (axis < 0) break;
 
-            if (axis >= 0 && axis < 8) win32_funcs->joystick_queue_event(&This->generic, DIDFT_ABSAXIS, axis, ie.value);
+            if (axis >= 0 && axis < 8) win32_funcs->joystick_queue_event(This->generic, DIDFT_ABSAXIS, axis, ie.value);
             else if (axis >= 8 && axis < 12)
             {
                 if (ie.code % 2) This->povs[axis - 8].y = ie.value;
                 else This->povs[axis - 8].x = ie.value;
-                win32_funcs->joystick_queue_event(&This->generic, DIDFT_POV, axis - 8, joystick_map_pov(&This->povs[axis - 8]));
+                win32_funcs->joystick_queue_event(This->generic, DIDFT_POV, axis - 8, joystick_map_pov(&This->povs[axis - 8]));
             }
             else FIXME("unhandled joystick axis event (code %d, value %d)\n", ie.code, ie.value);
 
@@ -977,42 +957,6 @@ static HRESULT CDECL unix_joystick_ff_send_cmd(struct unix_joystick *ptr, DWORD
 #endif
 }
 
-static const IDirectInputDevice8WVtbl JoystickWvt =
-{
-    IDirectInputDevice2WImpl_QueryInterface,
-    IDirectInputDevice2WImpl_AddRef,
-    IDirectInputDevice2WImpl_Release,
-    JoystickWGenericImpl_GetCapabilities,
-    IDirectInputDevice2WImpl_EnumObjects,
-    JoystickWGenericImpl_GetProperty,
-    JoystickWGenericImpl_SetProperty,
-    JoystickWGenericImpl_Acquire,
-    JoystickWGenericImpl_Unacquire,
-    JoystickWGenericImpl_GetDeviceState,
-    IDirectInputDevice2WImpl_GetDeviceData,
-    IDirectInputDevice2WImpl_SetDataFormat,
-    IDirectInputDevice2WImpl_SetEventNotification,
-    IDirectInputDevice2WImpl_SetCooperativeLevel,
-    JoystickWGenericImpl_GetObjectInfo,
-    IDirectInputDevice2WImpl_GetDeviceInfo,
-    IDirectInputDevice2WImpl_RunControlPanel,
-    IDirectInputDevice2WImpl_Initialize,
-    JoystickWGenericImpl_CreateEffect,
-    JoystickWGenericImpl_EnumEffects,
-    JoystickWGenericImpl_GetEffectInfo,
-    JoystickWGenericImpl_GetForceFeedbackState,
-    JoystickWGenericImpl_SendForceFeedbackCommand,
-    JoystickWGenericImpl_EnumCreatedEffectObjects,
-    IDirectInputDevice2WImpl_Escape,
-    JoystickWGenericImpl_Poll,
-    IDirectInputDevice2WImpl_SendDeviceData,
-    IDirectInputDevice7WImpl_EnumEffectsInFile,
-    IDirectInputDevice7WImpl_WriteEffectToFile,
-    JoystickWGenericImpl_BuildActionMap,
-    JoystickWGenericImpl_SetActionMap,
-    IDirectInputDevice8WImpl_GetImageInfo
-};
-
 #else  /* HAS_PROPER_HEADER */
 
 const struct dinput_device joystick_linuxinput_device = {
